#include "main_BasicLCDsetup.h" 
#include "GDD_Screens.h"
//#include "periphDev.h"
#include <libpic30.h>

extern float voltage_x1000;

// Configuration bits
_CONFIG2(FNOSC_PRI & POSCMOD_XT & IESO_ON & FCKSM_CSDCMD & OSCIOFNC_OFF) // Primary XT OSC with PLL
_CONFIG1(JTAGEN_OFF & FWDTEN_OFF & GCP_OFF & BKBUG_OFF & COE_OFF & ICS_PGx2 & WINDIS_OFF)   // JTAG off, watchdog timer off

int updateBTN1 = 1;


int main(void)
{
int ledstat = 0;
GOL_MSG msg; // GOL message structure to interact with GOL


char val[10]; 
double voltAVG;
int i;


	EEPROMInit();   					// initialize EEPROM
    TouchInit();    					// initialize touch screen
	GOLInit(); 							// initialize graphics library &

if(GRAPHICS_LIBRARY_VERSION != EEPROMReadWord(EEPROM_VERSION)){
        TouchCalibration();
        TouchStoreCalibration();
        EEPROMWriteWord(GRAPHICS_LIBRARY_VERSION,EEPROM_VERSION);
    }


TouchLoadCalibration();

/****************************************************************
Initialize the main screen created with Graphips Display Designer
this function resides in the GDD_Screens.c file which is automatically
generated by the designer.
*****************************************************************/
CreatemainScrn();

TRISDbits.TRISD3 = 0;
PORTDbits.RD3 = 1;

while(1)
{

 if (GOLDraw()) {				// Draw GOL object
      	TouchGetMsg(&msg);   		// Get message from touch screen
      	GOLMsg(&msg);        		// Process message
      }

     if (!updateBTN1 || !PORTDbits.RD4)
{
			if(!ledstat) 
      {
PORTDbits.RD3 = 0;	
//Bar( 25, 135, 55, 150 ); 
//SetColor(RED);
		OutTextXY((55)>>1,(275)>>1, "ON"); //x starting point, y starting point
		updateBTN1 = 1;
		ledstat = 1;
	  }

     else
      {  
PORTDbits.RD3 = 1;
//Bar( 25, 135, 55, 150 ); 
//SetColor(YELLOW);
//(x-position of lft top corner, y-position of lft top corner, x-position of rgt btm corner, y-position of rgt btm corner
		OutTextXY((55)>>1,(275)>>1, "OFF");
		updateBTN1 = 1;
		ledstat = 0;
      }
}
     
	}   
}
WORD GOLMsgCallback(WORD objMsg, OBJ_HEADER* pObj, GOL_MSG* pMsg){
WORD objectID;
objectID = GetObjID(pObj);

if (objectID == mainScrn_BTN1) {
		if (objMsg == BTN_MSG_PRESSED) // check if button is pressed

{
				__delay_ms(75);
				if (objMsg == BTN_MSG_PRESSED)
				__delay_ms(75);
    			updateBTN1 = 0;
}
				}					
return 1;
}	

WORD GOLDrawCallback(){
    return 1;
}
